#!/bin/perl
use HTTP::Lite;
use IO::Handle;

autoflush STDOUT 1;

if ($#ARGV < 0) {
  print "usage: fetch.pl <section>\n";
  exit 1;
}

my $section = $ARGV[0];

sub get_page($) {
  my ($url) = @_;
  my $http;
  while (1) {
    print "getting $url\n";
    $http = new HTTP::Lite;
    my $req = $http->request($url) or return undef;
    if ($req eq "302") {
      my @headers = $http->headers_array();
      $url = undef;
      foreach (@headers) {
        if ($_ =~ m|^Location:\s*(.*)$|) {
          $url = $1;
          next;
        }
      }
      if (defined($url)) {
        next;
      }
    }
    if ($req ne "200") {
      print "error: req is $req\n";
      return undef;
    }
    last;
  }
  my $body = $http->body();
  return $body;
}

my @files;


sub parse_list($) {
  my ($list_data) = @_;
  while ($list_data =~ m|files/(.*?/file\d+/)|gc) {
    push @files, $1;
  }
}

my $all_items = get_page("http://www.radioscanner.ru/files/$section/");

unless (defined($all_items)) {
  print "no data returned\n";
  exit 1;
}

open my $handle, ">index.html";
print $handle $all_items;
close $handle;

parse_list($all_items);

foreach (@files) {
  my $index_url = "http://www.radioscanner.ru/files/$_";
  my $index_page = get_page($index_url);
  next unless defined($index_page);
  my ($file_url) = $index_page =~ m|href=\"(http\:\/\/www\.radioscanner\.ru\/files\/download.*?)\"|;
  my ($subdir) = $_ =~ m|(file\d+)|;
  my ($number) = $_ =~ m|file(\d+)|;
  my $data = get_page($file_url);
  next unless defined($data);
  my ($filename) = $file_url =~ m|([^/]*)$|;
  mkdir $subdir;
  open my $handle, ">$subdir/$filename";
  print $handle $data;
  close $handle;
  open $handle, ">$subdir/index$number.html";
  print $handle $index_page;
  close $handle;
  print "$filename\n";
}
